//+------------------------------------------------------------------+
//|                                         Check_TimeFrames.dll.mq4 |
//|                                         Copyright  Zhunko       |
//|25.05.2011 - 30.08.2011                  vadim@zhunko.ru          |
//+------------------------------------------------------------------+
#property copyright "Copyright  Zhunko"
#property link      "vadim@zhunko.ru"
#property show_inputs
#include <TimeFrames.mqh> //    "TimeFrames.dll"       MT4  MT5.
//  . 
#define PERIOD_M1                         1 // 1 .
#define PERIOD_M2                         2 // 2 .
#define PERIOD_M3                         3 // 3 .
#define PERIOD_M4                         4 // 3 .
#define PERIOD_M5                         5 // 5 .
#define PERIOD_M6                         6 // 6 .
#define PERIOD_M10                       10 // 10 .
#define PERIOD_M12                       12 // 12 .
#define PERIOD_M15                       15 // 15 .
#define PERIOD_M20                       20 // 20 .
#define PERIOD_M30                       30 // 30 .
#define PERIOD_H1                        60 // 1 .
#define PERIOD_H2                       120 // 2 .
#define PERIOD_H3                       180 // 3 .
#define PERIOD_H4                       240 // 4 .
#define PERIOD_H6                       360 // 6 .
#define PERIOD_H8                       480 // 8 .
#define PERIOD_H12                      720 // 12 .
#define PERIOD_D1                      1440 // 1 .
#define PERIOD_W1                     10080 // 1 .
#define PERIOD_MN1                    43200 // 1 .
#define PERIOD_MN1_28                 40320 //  MN1 28 .
#define PERIOD_MN1_29                 41760 //  MN1 29 .
#define PERIOD_MN1_30                 43200 //  MN1 30 .
#define PERIOD_MN1_31                 44640 //  MN1 31 .
#define PERIOD_Q1                    129600 // 1 .
#define PERIOD_YR1                   518400 // 1 .
#define PERIOD_YR4                  2073600 // 4 .
//  . 
extern bool AllCheck            = false; //     .
extern bool CheckName9          = false; //    "tfCheckName9()".
extern bool CheckName21         = false; //    "tfCheckName21()".
extern bool CheckName24         = false; //    "tfCheckName24()".
extern bool CheckNameReturn9    = false; //    "tfCheckNameReturn9()".
extern bool CheckNameReturn21   = false; //    "tfCheckNameReturn21()".
extern bool CheckNameReturn24   = false; //    "tfCheckNameReturn24()".
extern bool CheckPeriod9        = false; //    "tfCheckPeriod9()".
extern bool CheckPeriod24       = false; //    "tfCheckPeriod24()".
extern bool NameByPeriod9       = false; //    "tfNameByPeriod9()".
extern bool NameByPeriod24      = false; //    "tfNameByPeriod24()".
extern bool NameChart9          = false; //    "tfNameChart9()".
extern bool NameChart24         = false; //    "tfNameChart24()".
extern bool NameChartByPeriod9  = false; //    "tfNameChartByPeriod9()".
extern bool NameChartByPeriod24 = false; //    "tfNameChartByPeriod24()".
extern bool NamePeriod9         = false; //    "tfNamePeriod9()".
extern bool NamePeriod24        = false; //    "tfNamePeriod24()".
extern bool NumberByPeriod9     = false; //    "tfNumberByPeriod9()".
extern bool NumberByPeriod24    = false; //    "tfNumberByPeriod24()".
extern bool Period9             = false; //    "tfPeriod9()".
extern bool Period24            = false; //    "tfPeriod24()".
extern bool PeriodByName9       = false; //    "tfPeriodByName9()".
extern bool PeriodByName24      = false; //    "tfPeriodByName24()".
//  . 
int    gl_aiPeriods9[10] = {PERIOD_M1, PERIOD_M5, PERIOD_M15, PERIOD_M30, PERIOD_H1, PERIOD_H4, PERIOD_D1, PERIOD_W1, PERIOD_MN1, 0};
int    gl_aiPeriods24[25] = {PERIOD_M1, PERIOD_M2, PERIOD_M3, PERIOD_M4, PERIOD_M5, PERIOD_M6, PERIOD_M10, PERIOD_M12, PERIOD_M15,
                             PERIOD_M20, PERIOD_M30, PERIOD_H1, PERIOD_H2, PERIOD_H3, PERIOD_H4, PERIOD_H6, PERIOD_H8, PERIOD_H12,
                             PERIOD_D1, PERIOD_W1, PERIOD_MN1, PERIOD_Q1, PERIOD_YR1, PERIOD_YR4, 0};
string gl_asNamePeriod9[10] = {"M1", "M5", "M15", "M30", "H1", "H4", "D1", "W1", "MN1", ""};
string gl_asNamePeriod24[25] = {"M1", "M2", "M3", "M4", "M5", "M6", "M10", "M12", "M15", "M20", "M30", "H1", "H2", "H3", "H4", "H6", "H8", "H12", "D1", "W1", "MN1", "Q1", "YR1", "YR4", ""};
//
void start()
 {
  int i = 0;
  //======================================================================================================================================================================================================================================
  // 1.       4.   TRUE      FALSE    .
  if (AllCheck || CheckName9)
   {
    Alert("==== tfCheckName9() ====");
    for (i = 0; i < 25; i++) Alert(i, "  ", gl_asNamePeriod24[i], " = ", tfCheckName9(gl_asNamePeriod24[i]));
   }
  //======================================================================================================================================================================================================================================
  // 2.       5.   TRUE      FALSE    .
  if (AllCheck || CheckName21)
   {
    Alert("==== tfCheckName21() ====");
    for (i = 0; i < 25; i++) Alert(i, "  ", gl_asNamePeriod24[i], " = ", tfCheckName21(gl_asNamePeriod24[i]));
   }
  //======================================================================================================================================================================================================================================
  // 3.        .   TRUE      FALSE    .
  if (AllCheck || CheckName24)
   {
    Alert("==== tfCheckName24() ====");
    for (i = 0; i < 25; i++) Alert(i, "  ", gl_asNamePeriod24[i], " = ", tfCheckName24(gl_asNamePeriod24[i]));
   }
  //======================================================================================================================================================================================================================================
  // 4.          4.         
  //                 .
  if (AllCheck || CheckNameReturn9)
   {
    Alert("==== tfCheckNameReturn9() ====");
    for (i = 0; i < 25; i++) Alert(i, "  ", gl_asNamePeriod24[i], " = ", tfCheckNameReturn9(gl_asNamePeriod24[i]));
   }
  //======================================================================================================================================================================================================================================
  // 5.          5.         
  //                 .
  if (AllCheck || CheckNameReturn21)
   {
    Alert("==== tfCheckNameReturn21() ====");
    for (i = 0; i < 25; i++) Alert(i, "  ", gl_asNamePeriod24[i], " = ", tfCheckNameReturn21(gl_asNamePeriod24[i]));
   }
  //======================================================================================================================================================================================================================================
  // 6.           .         
  //                 .
  if (AllCheck || CheckNameReturn24)
   {
    Alert("==== tfCheckName24Return() ====");
    for (i = 0; i < 25; i++) Alert(i, "  ", gl_asNamePeriod24[i], " = ", tfCheckNameReturn24(gl_asNamePeriod24[i]));
   }
  //======================================================================================================================================================================================================================================
  // 7.          .
  //      ,   TRUE,  - FALSE.
  if (AllCheck || CheckPeriod9)
   {
    Alert("==== tfCheckPeriod9() ====");
    for (i = 0; i < 25; i++) Alert(i, "  ", gl_aiPeriods24[i], " = ", tfCheckPeriod9(gl_aiPeriods24[i]));
   }
  //======================================================================================================================================================================================================================================
  // 8.          .
  //      ,   TRUE,  - FALSE.
  if (AllCheck || CheckPeriod24)
   {
    Alert("==== tfCheckPeriod24() ====");
    for (i = 0; i < 25; i++) Alert(i, "  ", gl_aiPeriods24[i], " = ", tfCheckPeriod24(gl_aiPeriods24[i]));
   }
  //======================================================================================================================================================================================================================================
  // 9.          .
  if (AllCheck || NameByPeriod9)
   {
    Alert("==== tfNameByPeriod9() ====");
    for (i = 0; i < 9; i++) Alert(i, "  ", tfNameByPeriod9(gl_aiPeriods9[i]));
   }
  //======================================================================================================================================================================================================================================
  //10.          .
  if (AllCheck || NameByPeriod24)
   {
    Alert("==== tfNameByPeriod24() ====");
    for (i = 0; i < 24; i++) Alert(i, "  ", tfNameByPeriod24(gl_aiPeriods24[i]));
   }
  //======================================================================================================================================================================================================================================
  //11.           .
  if (AllCheck || NameChart9)
   {
    Alert("==== tfNameChart9() ====");
    for (i = 0; i < 9; i++) Alert(i, "  ", tfNameChart9(i));
   }
  //======================================================================================================================================================================================================================================
  //12.           .
  if (AllCheck || NameChart24)
   {
    Alert("==== tfNameChart24() ====");
    for (i = 0; i < 24; i++) Alert(i, "  ", tfNameChart24(i));
   }
  //======================================================================================================================================================================================================================================
  //13.            .
  if (AllCheck || NameChartByPeriod9)
   {
    Alert("==== tfNameChartByPeriod9() ====");
    for (i = 0; i < 9; i++) Alert(i, "  ", tfNameChartByPeriod9(gl_aiPeriods9[i]));
   }
  //======================================================================================================================================================================================================================================
  //14.            .
  if (AllCheck || NameChartByPeriod24)
   {
    Alert("==== tfNameChartByPeriod24() ====");
    for (i = 0; i < 24; i++) Alert(i, "  ", tfNameChartByPeriod24(gl_aiPeriods24[i]));
   }
  //======================================================================================================================================================================================================================================
  //15.        .
  if (AllCheck || NamePeriod9)
   {
    Alert("==== tfNamePeriod9() ====");
    for (i = 0; i < 9; i++) Alert(i, "  ", tfNamePeriod9(i));
   }
  //======================================================================================================================================================================================================================================
  //16.        .
  if (AllCheck || NamePeriod24)
   {
    Alert("==== tfNamePeriod24() ====");
    for (i = 0; i < 24; i++) Alert(i, "  ", tfNamePeriod24(i));
   }
  //======================================================================================================================================================================================================================================
  //17.             .
  //            -1.
  if (AllCheck || NumberByPeriod9)
   {
    Alert("==== tfNumberByPeriod9() ====");
    for (i = 0; i < 9; i++) Alert(i, "  ", gl_aiPeriods9[i], "  ", tfNumberByPeriod9(gl_aiPeriods9[i]));
   }
  //======================================================================================================================================================================================================================================
  //18.             .
  //            -1.
  if (AllCheck || NumberByPeriod24)
   {
    Alert("==== tfNumberByPeriod24() ====");
    for (i = 0; i < 24; i++) Alert(i, "  ", gl_aiPeriods24[i], "  ", tfNumberByPeriod24(gl_aiPeriods24[i]));
   }
  //======================================================================================================================================================================================================================================
  //19.          .         -1.
  if (AllCheck || Period9)
   {
    Alert("==== tfPeriod9() ====");
    for (i = 0; i < 9; i++) Alert(i, "  ", tfPeriod9(i));
   }
  //======================================================================================================================================================================================================================================
  //20.          .         -1.
  if (AllCheck || Period24)
   {
    Alert("==== tfPeriod24() ====");
    for (i = 0; i < 24; i++) Alert(i, "  ", tfPeriod24(i));
   }
  //======================================================================================================================================================================================================================================
  //21.           .         -1.
  if (AllCheck || PeriodByName9)
   {
    Alert("==== tfPeriodByName9() ====");
    for (i = 0; i < 9; i++) Alert(i, "  ", gl_asNamePeriod9[i], "  ", tfPeriodByName9(gl_asNamePeriod9[i]));
   }
  //======================================================================================================================================================================================================================================
  //22.           .         -1.
  if (AllCheck || PeriodByName24)
   {
    Alert("==== tfPeriodByName24() ====");
    for (i = 0; i < 24; i++) Alert(i, "  ", gl_asNamePeriod24[i], "  ", tfPeriodByName24(gl_asNamePeriod24[i]));
   }
  //======================================================================================================================================================================================================================================
 }
//